/**
 * Classe Contatore
 * @author Barbara Pettazzoni
 * @version 1 14/05/2008
 */
public class Contatore
{
	private int valore, valMax;
	private boolean errore;
	
	/**
	 * Metodo che assegna il valore massimo al contatore.
	 * Se il valore che si presenta e' inferiore o uguale a 0, il contatore transita ina una condizione d'errore.
	 * @param valore valore a cui assegnare il valore massimo
	 */
	public void setMaxVal(int valore)
	{
		if(valore <= 0)
			errore = true;
		else
		    valMax = valore;
	}
	
	/**
	 * Metodo che incrementa il contatore. Se si cerca di incrementare oltre il limite, il contatore entra in uno stato
	 * d'errore
	 */
	public void incrementa()
	{
		if(valore >= valMax)
			errore = true;
		else
		   valore++;
	}
	
	/**
	 * Metodo che "inizializza" il contatore, ovvero il valore attuale e il valore massimo son posti a 0,
	 * lo stato d'errore e' resettato.
	 */
	public void azzera()
	{
		valore = 0;
		valMax = 0;
		errore = false;
	}
	
	
	/**
	 * Metodo che restituisc il valore attuale del contatore.
	 * @return Il valore attuale del contatore.
	 */
	public int leggi()
	{
		return valore;
	}
	
	/**
	 * Metodo che stampa lo stato del contatore (se non si e' in una condizione d'errore, viene
	 * stampato il valore, altrimenti un messaggio d'errore)
	 */
	public void visualizza()
	{
		if(!isError())
		{
			System.out.println("Valore = " + valore);
		}
		else
		{
			System.out.println("Errore!");
		}
	}
	
	/**
	 * Metodo che restituisce se siamo in una condizione d'errore o meno.
	 * @return Lo stato del contatore, siamo in una condizione d'errore?
	 */
	public boolean isError()
	{
		return errore;
	}
}